package ru.dbotthepony.mc.otm;

import net.minecraft.client.gui.screens.MenuScreens;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderers;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.stats.StatFormatter;
import net.minecraft.util.valueproviders.UniformInt;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.food.FoodProperties;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.OreBlock;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.Material;
import net.minecraft.world.level.material.MaterialColor;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.registries.ForgeRegistry;
import net.minecraftforge.registries.RegistryBuilder;
import ru.dbotthepony.mc.otm.android.AndroidFeature;
import ru.dbotthepony.mc.otm.android.AndroidResearchBuilder;
import ru.dbotthepony.mc.otm.android.AndroidResearchType;
import ru.dbotthepony.mc.otm.android.feature.AndroidLimbOverclocking;
import ru.dbotthepony.mc.otm.android.feature.AndroidNanobotsArmor;
import ru.dbotthepony.mc.otm.android.feature.AndroidNanobotsRegeneration;
import ru.dbotthepony.mc.otm.block.*;
import ru.dbotthepony.mc.otm.block.entity.*;
import ru.dbotthepony.mc.otm.android.AndroidFeatureType;
import ru.dbotthepony.mc.otm.client.render.BlackHoleRenderer;
import ru.dbotthepony.mc.otm.client.render.SkinElement;
import ru.dbotthepony.mc.otm.item.*;
import ru.dbotthepony.mc.otm.menu.*;
import ru.dbotthepony.mc.otm.client.screen.*;

import java.math.BigDecimal;

public class Registry {
	public static final DamageSource DAMAGE_BECOME_ANDROID = new DamageSource("otm_become_android");
	public static final DamageSource DAMAGE_BECOME_HUMANE = new DamageSource("otm_become_humane");
	public static final DamageSource DAMAGE_EVENT_HORIZON = new DamageSource("otm_event_horizon");

	static {
		DAMAGE_BECOME_ANDROID.bypassArmor().bypassInvul().bypassMagic();
		DAMAGE_BECOME_HUMANE.bypassArmor().bypassInvul().bypassMagic();
		DAMAGE_EVENT_HORIZON.bypassMagic().bypassArmor();
	}

	public static final ForgeRegistry<AndroidFeatureType<?>> ANDROID_FEATURES;
	public static final ForgeRegistry<AndroidResearchType<?>> ANDROID_RESEARCH;

	static {
		var builder = new RegistryBuilder<AndroidFeatureType<?>>();
		builder.setName(new ResourceLocation(OverdriveThatMatters.MOD_ID, "android_features"));

		// make it shut up
		builder.setType(c(AndroidFeatureType.class));
		ANDROID_FEATURES = (ForgeRegistry<AndroidFeatureType<?>>) builder.create();

		var builder2 = new RegistryBuilder<AndroidResearchType<?>>();
		builder2.setName(new ResourceLocation(OverdriveThatMatters.MOD_ID, "android_research"));

		// make it shut up
		builder2.setType(c(AndroidResearchType.class));
		ANDROID_RESEARCH = (ForgeRegistry<AndroidResearchType<?>>) builder2.create();
	}

	public static void dummy() {}

	private static <T> Class<T> c(Class<?> cls) { return (Class<T>) cls; }

	record CrateProps(MaterialColor color, ResourceLocation name) {
		public CrateProps(MaterialColor color, String name) {
			this(color, new ResourceLocation(OverdriveThatMatters.MOD_ID, "crate_" + name));
		}
	}

	public static final CrateProps[] CRATES = new CrateProps[] {
		new CrateProps(MaterialColor.COLOR_RED, "red"),
		new CrateProps(MaterialColor.COLOR_BLUE, "blue"),
		new CrateProps(MaterialColor.COLOR_YELLOW, "yellow"),
		new CrateProps(MaterialColor.COLOR_GREEN, "green"),
		new CrateProps(MaterialColor.COLOR_BLACK, "black"),
		new CrateProps(MaterialColor.COLOR_PINK, "pink"),
		new CrateProps(MaterialColor.COLOR_PURPLE, "purple"),
	};

	public static class Names {
		// blocks
		public static final ResourceLocation ANDROID_STATION = new ResourceLocation(OverdriveThatMatters.MOD_ID, "android_station");
		public static final ResourceLocation BATTERY_BANK = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_bank");
		public static final ResourceLocation MATTER_DECOMPOSER = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_decomposer");
		public static final ResourceLocation MATTER_CAPACITOR_BANK = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_capacitor_bank");
		public static final ResourceLocation MATTER_CABLE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_cable");
		public static final ResourceLocation PATTERN_STORAGE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "pattern_storage");
		public static final ResourceLocation MATTER_SCANNER = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_scanner");
		public static final ResourceLocation MATTER_PANEL = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_panel");
		public static final ResourceLocation MATTER_REPLICATOR = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_replicator");
		public static final ResourceLocation MATTER_BOTTLER = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_bottler");
		public static final ResourceLocation DRIVE_VIEWER = new ResourceLocation(OverdriveThatMatters.MOD_ID, "drive_viewer");

		public static final ResourceLocation BLACK_HOLE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "black_hole");
		public static final ResourceLocation CARGO_CRATE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "cargo_crate");

		// building blocks
		public static final ResourceLocation TRITANIUM_BLOCK = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_block");
		public static final ResourceLocation TRITANIUM_STRIPED_BLOCK = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_striped_block");

		public static final ResourceLocation CARBON_FIBRE_BLOCK = new ResourceLocation(OverdriveThatMatters.MOD_ID, "carbon_fibre_block");

		// capabilities
		public static final ResourceLocation ANDROID_CAPABILITY = new ResourceLocation(OverdriveThatMatters.MOD_ID, "android_capability");

		// items
		public static final ResourceLocation PILL_ANDROID = new ResourceLocation(OverdriveThatMatters.MOD_ID, "pill_android");
		public static final ResourceLocation PILL_HUMANE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "pill_humane");

		public static final ResourceLocation BATTERY_CRUDE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_crude");
		public static final ResourceLocation BATTERY_BASIC = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_basic");
		public static final ResourceLocation BATTERY_NORMAL = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_normal");
		public static final ResourceLocation BATTERY_DENSE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_dense");
		public static final ResourceLocation BATTERY_CAPACITOR = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_capacitor");
		public static final ResourceLocation BATTERY_CREATIVE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "battery_creative");

		public static final ResourceLocation MATTER_CAPACITOR_PARTS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_capacitor_parts");
		public static final ResourceLocation MATTER_CAPACITOR_BASIC = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_capacitor_basic");
		public static final ResourceLocation MATTER_CAPACITOR_NORMAL = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_capacitor_normal");
		public static final ResourceLocation MATTER_CAPACITOR_DENSE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_capacitor_dense");
		public static final ResourceLocation MATTER_CAPACITOR_CREATIVE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_capacitor_creative");

		public static final ResourceLocation PATTERN_DRIVE_NORMAL = new ResourceLocation(OverdriveThatMatters.MOD_ID, "pattern_drive_normal");
		public static final ResourceLocation PATTERN_DRIVE_CREATIVE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "pattern_drive_creative");

		public static final ResourceLocation NUTRIENT_PASTE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nutrient_paste");

		public static final ResourceLocation PORTABLE_CONDENSATION_DRIVE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "portable_condensation_drive");
		public static final ResourceLocation PORTABLE_DENSE_CONDENSATION_DRIVE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "portable_dense_condensation_drive");

		// items: crafting components
		public static final ResourceLocation TRITANIUM_INGOT = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_ingot");

		public static final ResourceLocation MATTER_IO_PORT = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_io_port");
		public static final ResourceLocation MATTER_TRANSFORM_MATRIX = new ResourceLocation(OverdriveThatMatters.MOD_ID, "matter_transform_matrix");

		public static final ResourceLocation ENERGY_BUS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "energy_bus");
		public static final ResourceLocation ELECTRIC_PARTS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "electric_parts");

		public static final ResourceLocation MACHINE_FRAME = new ResourceLocation(OverdriveThatMatters.MOD_ID, "machine_frame");
		public static final ResourceLocation TRITANIUM_PLATE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_plate");
		public static final ResourceLocation IRON_PLATE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "iron_plate");
		public static final ResourceLocation COPPER_WIRING = new ResourceLocation(OverdriveThatMatters.MOD_ID, "copper_wiring");
		public static final ResourceLocation GOLD_WIRING = new ResourceLocation(OverdriveThatMatters.MOD_ID, "gold_wiring");

		public static final ResourceLocation PORTABLE_CONDENSATION_DRIVE_CASING = new ResourceLocation(OverdriveThatMatters.MOD_ID, "portable_condensation_drive_casing");
		public static final ResourceLocation PORTABLE_DENSE_CONDENSATION_DRIVE_CASING = new ResourceLocation(OverdriveThatMatters.MOD_ID, "portable_dense_condensation_drive_casing");

		public static final ResourceLocation CIRCUIT_PLATING = new ResourceLocation(OverdriveThatMatters.MOD_ID, "circuit_plating");
		public static final ResourceLocation BASIC_CONTROL_CIRCUIT = new ResourceLocation(OverdriveThatMatters.MOD_ID, "basic_control_circuit");
		public static final ResourceLocation ADVANCED_CONTROL_CIRCUIT = new ResourceLocation(OverdriveThatMatters.MOD_ID, "advanced_control_circuit");

		public static final ResourceLocation TRITANIUM_ORE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_ore");
		public static final ResourceLocation DEEPSLATE_TRITANIUM_ORE = new ResourceLocation(OverdriveThatMatters.MOD_ID, "deepslate_tritanium_ore");
		public static final ResourceLocation TRITANIUM_RAW_BLOCK = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_raw_block");
		public static final ResourceLocation TRITANIUM_ORE_CLUMP = new ResourceLocation(OverdriveThatMatters.MOD_ID, "tritanium_ore_clump");

		// android features and research
		public static final ResourceLocation AIR_BAGS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "air_bags");

		public static final ResourceLocation LIMB_OVERCLOCKING = new ResourceLocation(OverdriveThatMatters.MOD_ID, "limb_overclocking");
		public static final ResourceLocation LIMB_OVERCLOCKING_1 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "limb_overclocking_1");
		public static final ResourceLocation LIMB_OVERCLOCKING_2 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "limb_overclocking_2");
		public static final ResourceLocation LIMB_OVERCLOCKING_3 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "limb_overclocking_3");
		public static final ResourceLocation LIMB_OVERCLOCKING_4 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "limb_overclocking_4");

		public static final ResourceLocation[] LIMB_OVERCLOCKING_LIST = new ResourceLocation[] { LIMB_OVERCLOCKING_1, LIMB_OVERCLOCKING_2, LIMB_OVERCLOCKING_3, LIMB_OVERCLOCKING_4 };

		public static final ResourceLocation NANOBOTS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots");
		public static final ResourceLocation NANOBOTS_REGENERATION = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_regeneration");
		public static final ResourceLocation NANOBOTS_REGENERATION_1 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_regeneration_1");
		public static final ResourceLocation NANOBOTS_REGENERATION_2 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_regeneration_2");
		public static final ResourceLocation NANOBOTS_REGENERATION_3 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_regeneration_3");
		public static final ResourceLocation NANOBOTS_REGENERATION_4 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_regeneration_4");

		public static final ResourceLocation[] NANOBOTS_REGENERATION_LIST = new ResourceLocation[] { NANOBOTS_REGENERATION_1, NANOBOTS_REGENERATION_2, NANOBOTS_REGENERATION_3, NANOBOTS_REGENERATION_4 };

		public static final ResourceLocation NANOBOTS_ARMOR = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor");

		public static final ResourceLocation NANOBOTS_ARMOR_STRENGTH_1 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor_strength_1");
		public static final ResourceLocation NANOBOTS_ARMOR_STRENGTH_2 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor_strength_2");
		public static final ResourceLocation NANOBOTS_ARMOR_STRENGTH_3 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor_strength_3");
		public static final ResourceLocation[] NANOBOTS_ARMOR_STRENGTH_LIST = new ResourceLocation[] {
			NANOBOTS_ARMOR_STRENGTH_1,
			NANOBOTS_ARMOR_STRENGTH_2,
			NANOBOTS_ARMOR_STRENGTH_3,
		};

		public static final ResourceLocation NANOBOTS_ARMOR_SPEED_1 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor_speed_1");
		public static final ResourceLocation NANOBOTS_ARMOR_SPEED_2 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor_speed_2");
		public static final ResourceLocation NANOBOTS_ARMOR_SPEED_3 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "nanobots_armor_speed_3");
		public static final ResourceLocation[] NANOBOTS_ARMOR_SPEED_LIST = new ResourceLocation[] {
			NANOBOTS_ARMOR_SPEED_1,
			NANOBOTS_ARMOR_SPEED_2,
			NANOBOTS_ARMOR_SPEED_3,
		};

		public static final ResourceLocation HYDRAULICS_OVERLOAD = new ResourceLocation(OverdriveThatMatters.MOD_ID, "hydraulics_overload");
		public static final ResourceLocation HYDRAULICS_OVERLOAD_1 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "hydraulics_overload_1");
		public static final ResourceLocation HYDRAULICS_OVERLOAD_2 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "hydraulics_overload_2");
		public static final ResourceLocation HYDRAULICS_OVERLOAD_3 = new ResourceLocation(OverdriveThatMatters.MOD_ID, "hydraulics_overload_3");

		// stats
		public static final ResourceLocation DAMAGE_ABSORBED = new ResourceLocation(OverdriveThatMatters.MOD_ID, "damage_absorbed");
		public static final ResourceLocation HEALTH_REGENERATED = new ResourceLocation(OverdriveThatMatters.MOD_ID, "health_regenerated");
		public static final ResourceLocation POWER_CONSUMED = new ResourceLocation(OverdriveThatMatters.MOD_ID, "power_consumed");
	}

	public static class Blocks {
		public static final BlockAndroidStation ANDROID_STATION = new BlockAndroidStation();
		public static final BlockBatteryBank BATTERY_BANK = new BlockBatteryBank();
		public static final BlockMatterDecomposer MATTER_DECOMPOSER = new BlockMatterDecomposer();
		public static final BlockMatterCapacitorBank MATTER_CAPACITOR_BANK = new BlockMatterCapacitorBank();
		public static final BlockMatterCable MATTER_CABLE = new BlockMatterCable();
		public static final BlockPatternStorage PATTERN_STORAGE = new BlockPatternStorage();
		public static final BlockMatterScanner MATTER_SCANNER = new BlockMatterScanner();
		public static final BlockMatterPanel MATTER_PANEL = new BlockMatterPanel();
		public static final BlockMatterReplicator MATTER_REPLICATOR = new BlockMatterReplicator();
		public static final BlockMatterBottler MATTER_BOTTLER = new BlockMatterBottler();
		public static final BlockDriveViewer DRIVE_VIEWER = new BlockDriveViewer();
		public static final BlockCargoCrate CARGO_CRATE = new BlockCargoCrate();

		public static final BlockBlackHole BLACK_HOLE = new BlockBlackHole();

		public static final Block TRITANIUM_ORE = new OreBlock(
			BlockBehaviour.Properties.of(Material.STONE)
			.strength(3.25F, 6.0F)
			.requiresCorrectToolForDrops(),
			UniformInt.of(0, 3)
		);

		public static final Block DEEPSLATE_TRITANIUM_ORE = new OreBlock(
			BlockBehaviour.Properties.of(Material.STONE)
			.strength(4.75F, 6.5F)
			.requiresCorrectToolForDrops(),
			UniformInt.of(0, 3)
		);

		public static final Block TRITANIUM_RAW_BLOCK = new Block(
			BlockBehaviour.Properties.of(Material.STONE)
			.strength(8.0F, 10F)
			.requiresCorrectToolForDrops()
		);

		public static final Block[] CRATES = new Block[Registry.CRATES.length];

		public static final Block TRITANIUM_BLOCK = new Block(
			BlockBehaviour.Properties.of(Material.METAL, MaterialColor.COLOR_LIGHT_BLUE)
				.sound(SoundType.BASALT)
				.requiresCorrectToolForDrops()
				.explosionResistance(80)
				.strength(4)
		);

		public static final Block TRITANIUM_STRIPED_BLOCK = new Block(
			BlockBehaviour.Properties.of(Material.METAL, MaterialColor.COLOR_LIGHT_BLUE)
				.sound(SoundType.BASALT)
				.requiresCorrectToolForDrops()
				.explosionResistance(80)
				.strength(4)
		);

		public static final Block CARBON_FIBRE_BLOCK = new Block(
			BlockBehaviour.Properties.of(Material.METAL, MaterialColor.COLOR_LIGHT_BLUE)
				.sound(SoundType.BASALT)
				.requiresCorrectToolForDrops()
				.explosionResistance(40)
				.strength(3)
		);

		static {
			for (int i = 0; i < Registry.CRATES.length; i++) {
				CRATES[i] = new Block(BlockBehaviour.Properties.of(Material.METAL, Registry.CRATES[i].color)
					.sound(SoundType.METAL)
					.requiresCorrectToolForDrops()
					.strength(5.0F, 6.0F));

				CRATES[i].setRegistryName(Registry.CRATES[i].name);
			}

			TRITANIUM_ORE.setRegistryName(Names.TRITANIUM_ORE);
			DEEPSLATE_TRITANIUM_ORE.setRegistryName(Names.DEEPSLATE_TRITANIUM_ORE);
			TRITANIUM_RAW_BLOCK.setRegistryName(Names.TRITANIUM_RAW_BLOCK);
			ANDROID_STATION.setRegistryName(Names.ANDROID_STATION);
			BATTERY_BANK.setRegistryName(Names.BATTERY_BANK);
			MATTER_DECOMPOSER.setRegistryName(Names.MATTER_DECOMPOSER);
			MATTER_CAPACITOR_BANK.setRegistryName(Names.MATTER_CAPACITOR_BANK);
			MATTER_CABLE.setRegistryName(Names.MATTER_CABLE);
			PATTERN_STORAGE.setRegistryName(Names.PATTERN_STORAGE);
			MATTER_SCANNER.setRegistryName(Names.MATTER_SCANNER);
			MATTER_PANEL.setRegistryName(Names.MATTER_PANEL);
			MATTER_REPLICATOR.setRegistryName(Names.MATTER_REPLICATOR);
			MATTER_BOTTLER.setRegistryName(Names.MATTER_BOTTLER);
			DRIVE_VIEWER.setRegistryName(Names.DRIVE_VIEWER);
			BLACK_HOLE.setRegistryName(Names.BLACK_HOLE);
			CARGO_CRATE.setRegistryName(Names.CARGO_CRATE);

			TRITANIUM_BLOCK.setRegistryName(Names.TRITANIUM_BLOCK);
			TRITANIUM_STRIPED_BLOCK.setRegistryName(Names.TRITANIUM_STRIPED_BLOCK);
			CARBON_FIBRE_BLOCK.setRegistryName(Names.CARBON_FIBRE_BLOCK);
		}

		@SubscribeEvent
		public static void register(final RegistryEvent.Register<Block> event) {
			event.getRegistry().register(ANDROID_STATION);
			event.getRegistry().register(BATTERY_BANK);
			event.getRegistry().register(MATTER_DECOMPOSER);
			event.getRegistry().register(MATTER_CAPACITOR_BANK);
			event.getRegistry().register(MATTER_CABLE);
			event.getRegistry().register(PATTERN_STORAGE);
			event.getRegistry().register(MATTER_SCANNER);
			event.getRegistry().register(MATTER_PANEL);
			event.getRegistry().register(MATTER_REPLICATOR);
			event.getRegistry().register(MATTER_BOTTLER);
			event.getRegistry().register(DRIVE_VIEWER);
			event.getRegistry().register(TRITANIUM_BLOCK);
			event.getRegistry().register(TRITANIUM_STRIPED_BLOCK);
			event.getRegistry().register(CARBON_FIBRE_BLOCK);
			event.getRegistry().register(BLACK_HOLE);
			event.getRegistry().register(CARGO_CRATE);
			event.getRegistry().register(TRITANIUM_ORE);
			event.getRegistry().register(DEEPSLATE_TRITANIUM_ORE);
			event.getRegistry().register(TRITANIUM_RAW_BLOCK);

			for (var crate : CRATES) {
				event.getRegistry().register(crate);
			}

			// OverdriveThatMatters.LOGGER.info("Registered blocks");
		}
	}

	public static class Items {
		public static final Item ANDROID_STATION = new BlockItem(Blocks.ANDROID_STATION, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item BATTERY_BANK = new BlockItem(Blocks.BATTERY_BANK, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_DECOMPOSER = new BlockItem(Blocks.MATTER_DECOMPOSER, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_CAPACITOR_BANK = new BlockItem(Blocks.MATTER_CAPACITOR_BANK, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_CABLE = new BlockItem(Blocks.MATTER_CABLE, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item PATTERN_STORAGE = new BlockItem(Blocks.PATTERN_STORAGE, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_SCANNER = new BlockItem(Blocks.MATTER_SCANNER, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_PANEL = new BlockItem(Blocks.MATTER_PANEL, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_REPLICATOR = new BlockItem(Blocks.MATTER_REPLICATOR, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_BOTTLER = new BlockItem(Blocks.MATTER_BOTTLER, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item DRIVE_VIEWER = new BlockItem(Blocks.DRIVE_VIEWER, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item CARGO_CRATE = new BlockItem(Blocks.CARGO_CRATE, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item TRITANIUM_ORE = new BlockItem(Blocks.TRITANIUM_ORE, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item DEEPSLATE_TRITANIUM_ORE = new BlockItem(Blocks.DEEPSLATE_TRITANIUM_ORE, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item TRITANIUM_RAW_BLOCK = new BlockItem(Blocks.TRITANIUM_RAW_BLOCK, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));

		public static final Item TRITANIUM_ORE_CLUMP = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item TRITANIUM_INGOT = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_IO_PORT = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MATTER_TRANSFORM_MATRIX = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item ENERGY_BUS = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item ELECTRIC_PARTS = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item MACHINE_FRAME = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item TRITANIUM_PLATE = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item IRON_PLATE = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item COPPER_WIRING = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item GOLD_WIRING = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item PORTABLE_CONDENSATION_DRIVE_CASING = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item PORTABLE_DENSE_CONDENSATION_DRIVE_CASING = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item CIRCUIT_PLATING = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item BASIC_CONTROL_CIRCUIT = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item ADVANCED_CONTROL_CIRCUIT = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));

		public static final Item BLACK_HOLE = new BlockItem(Blocks.BLACK_HOLE, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));

		public static final ItemPill PILL_ANDROID = new ItemPill(ItemPill.PillType.BECOME_ANDROID);
		public static final ItemPill PILL_HUMANE = new ItemPill(ItemPill.PillType.BECOME_HUMANE);

		public static final ItemBattery BATTERY_CRUDE = new ItemBattery(new BigDecimal(30_000), new BigDecimal(150), new BigDecimal(150));
		public static final ItemBattery BATTERY_BASIC = new ItemBattery(new BigDecimal(60_000), new BigDecimal(300), new BigDecimal(300));
		public static final ItemBattery BATTERY_NORMAL = new ItemBattery(new BigDecimal(250_000), new BigDecimal(1000), new BigDecimal(1000));
		public static final ItemBattery BATTERY_DENSE = new ItemBattery(new BigDecimal(1_000_000), new BigDecimal(2000), new BigDecimal(2000));
		public static final ItemBattery BATTERY_CAPACITOR = new ItemBattery(new BigDecimal(150_000), new BigDecimal(15000), new BigDecimal(15000));
		public static final ItemBattery BATTERY_CREATIVE = new ItemBattery();

		public static final Item MATTER_CAPACITOR_PARTS = new Item(new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final ItemMatterCapacitor MATTER_CAPACITOR_BASIC = new ItemMatterCapacitor(new BigDecimal("4"));
		public static final ItemMatterCapacitor MATTER_CAPACITOR_NORMAL = new ItemMatterCapacitor(new BigDecimal("10"));
		public static final ItemMatterCapacitor MATTER_CAPACITOR_DENSE = new ItemMatterCapacitor(new BigDecimal("40"));
		public static final ItemMatterCapacitor MATTER_CAPACITOR_CREATIVE = new ItemMatterCapacitor();

		public static final ItemPatternStorage PATTERN_DRIVE_NORMAL = new ItemPatternStorage(4);
		public static final ItemPatternStorage PATTERN_DRIVE_CREATIVE = new ItemPatternStorage();

		public static final ItemPortableCondensationDrive PORTABLE_CONDENSATION_DRIVE = new ItemPortableCondensationDrive(4000);
		public static final ItemPortableCondensationDrive PORTABLE_DENSE_CONDENSATION_DRIVE = new ItemPortableCondensationDrive(25000);

		public static final Item NUTRIENT_PASTE = new Item(new Item.Properties().stacksTo(64).food(new FoodProperties.Builder().meat().nutrition(8).saturationMod(0.9F).build()).tab(OverdriveThatMatters.CREATIVE_TAB));

		public static final Item[] CRATES = new Item[Registry.CRATES.length];

		public static final Item TRITANIUM_BLOCK = new BlockItem(Blocks.TRITANIUM_BLOCK, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item TRITANIUM_STRIPED_BLOCK = new BlockItem(Blocks.TRITANIUM_STRIPED_BLOCK, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
		public static final Item CARBON_FIBRE_BLOCK = new BlockItem(Blocks.CARBON_FIBRE_BLOCK, new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));

		static {
			for (int i = 0; i < Registry.CRATES.length; i++) {
				CRATES[i] = new BlockItem(Blocks.CRATES[i], new Item.Properties().stacksTo(64).tab(OverdriveThatMatters.CREATIVE_TAB));
				CRATES[i].setRegistryName(Registry.CRATES[i].name);
			}

			ANDROID_STATION.setRegistryName(Names.ANDROID_STATION);
			BATTERY_BANK.setRegistryName(Names.BATTERY_BANK);
			MATTER_DECOMPOSER.setRegistryName(Names.MATTER_DECOMPOSER);
			MATTER_CAPACITOR_BANK.setRegistryName(Names.MATTER_CAPACITOR_BANK);
			MATTER_CABLE.setRegistryName(Names.MATTER_CABLE);
			PATTERN_STORAGE.setRegistryName(Names.PATTERN_STORAGE);
			MATTER_SCANNER.setRegistryName(Names.MATTER_SCANNER);
			MATTER_PANEL.setRegistryName(Names.MATTER_PANEL);
			MATTER_REPLICATOR.setRegistryName(Names.MATTER_REPLICATOR);
			MATTER_BOTTLER.setRegistryName(Names.MATTER_BOTTLER);
			DRIVE_VIEWER.setRegistryName(Names.DRIVE_VIEWER);
			BLACK_HOLE.setRegistryName(Names.BLACK_HOLE);
			CARGO_CRATE.setRegistryName(Names.CARGO_CRATE);

			TRITANIUM_ORE.setRegistryName(Names.TRITANIUM_ORE);
			DEEPSLATE_TRITANIUM_ORE.setRegistryName(Names.DEEPSLATE_TRITANIUM_ORE);
			TRITANIUM_RAW_BLOCK.setRegistryName(Names.TRITANIUM_RAW_BLOCK);
			TRITANIUM_ORE_CLUMP.setRegistryName(Names.TRITANIUM_ORE_CLUMP);
			TRITANIUM_INGOT.setRegistryName(Names.TRITANIUM_INGOT);
			MATTER_IO_PORT.setRegistryName(Names.MATTER_IO_PORT);
			MATTER_TRANSFORM_MATRIX.setRegistryName(Names.MATTER_TRANSFORM_MATRIX);
			ENERGY_BUS.setRegistryName(Names.ENERGY_BUS);
			ELECTRIC_PARTS.setRegistryName(Names.ELECTRIC_PARTS);
			MACHINE_FRAME.setRegistryName(Names.MACHINE_FRAME);
			TRITANIUM_PLATE.setRegistryName(Names.TRITANIUM_PLATE);
			IRON_PLATE.setRegistryName(Names.IRON_PLATE);
			COPPER_WIRING.setRegistryName(Names.COPPER_WIRING);
			GOLD_WIRING.setRegistryName(Names.GOLD_WIRING);
			PORTABLE_CONDENSATION_DRIVE_CASING.setRegistryName(Names.PORTABLE_CONDENSATION_DRIVE_CASING);
			PORTABLE_DENSE_CONDENSATION_DRIVE_CASING.setRegistryName(Names.PORTABLE_DENSE_CONDENSATION_DRIVE_CASING);
			CIRCUIT_PLATING.setRegistryName(Names.CIRCUIT_PLATING);
			BASIC_CONTROL_CIRCUIT.setRegistryName(Names.BASIC_CONTROL_CIRCUIT);
			ADVANCED_CONTROL_CIRCUIT.setRegistryName(Names.ADVANCED_CONTROL_CIRCUIT);

			PILL_ANDROID.setRegistryName(Names.PILL_ANDROID);
			PILL_HUMANE.setRegistryName(Names.PILL_HUMANE);
			BATTERY_CRUDE.setRegistryName(Names.BATTERY_CRUDE);
			BATTERY_BASIC.setRegistryName(Names.BATTERY_BASIC);
			BATTERY_NORMAL.setRegistryName(Names.BATTERY_NORMAL);
			BATTERY_DENSE.setRegistryName(Names.BATTERY_DENSE);
			BATTERY_CAPACITOR.setRegistryName(Names.BATTERY_CAPACITOR);
			BATTERY_CREATIVE.setRegistryName(Names.BATTERY_CREATIVE);

			MATTER_CAPACITOR_PARTS.setRegistryName(Names.MATTER_CAPACITOR_PARTS);
			MATTER_CAPACITOR_BASIC.setRegistryName(Names.MATTER_CAPACITOR_BASIC);
			MATTER_CAPACITOR_NORMAL.setRegistryName(Names.MATTER_CAPACITOR_NORMAL);
			MATTER_CAPACITOR_DENSE.setRegistryName(Names.MATTER_CAPACITOR_DENSE);
			MATTER_CAPACITOR_CREATIVE.setRegistryName(Names.MATTER_CAPACITOR_CREATIVE);

			PATTERN_DRIVE_NORMAL.setRegistryName(Names.PATTERN_DRIVE_NORMAL);
			PATTERN_DRIVE_CREATIVE.setRegistryName(Names.PATTERN_DRIVE_CREATIVE);
			PORTABLE_CONDENSATION_DRIVE.setRegistryName(Names.PORTABLE_CONDENSATION_DRIVE);
			PORTABLE_DENSE_CONDENSATION_DRIVE.setRegistryName(Names.PORTABLE_DENSE_CONDENSATION_DRIVE);

			NUTRIENT_PASTE.setRegistryName(Names.NUTRIENT_PASTE);

			TRITANIUM_BLOCK.setRegistryName(Names.TRITANIUM_BLOCK);
			TRITANIUM_STRIPED_BLOCK.setRegistryName(Names.TRITANIUM_STRIPED_BLOCK);
			CARBON_FIBRE_BLOCK.setRegistryName(Names.CARBON_FIBRE_BLOCK);
		}

		@SubscribeEvent
		public static void register(final RegistryEvent.Register<Item> event) {
			event.getRegistry().register(ANDROID_STATION);
			event.getRegistry().register(BATTERY_BANK);
			event.getRegistry().register(MATTER_DECOMPOSER);
			event.getRegistry().register(MATTER_CAPACITOR_BANK);
			event.getRegistry().register(MATTER_CABLE);
			event.getRegistry().register(PATTERN_STORAGE);
			event.getRegistry().register(MATTER_SCANNER);
			event.getRegistry().register(MATTER_PANEL);
			event.getRegistry().register(MATTER_REPLICATOR);
			event.getRegistry().register(MATTER_BOTTLER);
			event.getRegistry().register(DRIVE_VIEWER);
			event.getRegistry().register(BLACK_HOLE);
			event.getRegistry().register(CARGO_CRATE);

			event.getRegistry().register(TRITANIUM_ORE);
			event.getRegistry().register(DEEPSLATE_TRITANIUM_ORE);
			event.getRegistry().register(TRITANIUM_RAW_BLOCK);

			event.getRegistry().register(TRITANIUM_ORE_CLUMP);
			event.getRegistry().register(TRITANIUM_INGOT);
			event.getRegistry().register(MATTER_IO_PORT);
			event.getRegistry().register(MATTER_TRANSFORM_MATRIX);
			event.getRegistry().register(ENERGY_BUS);
			event.getRegistry().register(ELECTRIC_PARTS);
			event.getRegistry().register(MACHINE_FRAME);
			event.getRegistry().register(TRITANIUM_PLATE);
			event.getRegistry().register(IRON_PLATE);
			event.getRegistry().register(COPPER_WIRING);
			event.getRegistry().register(GOLD_WIRING);
			event.getRegistry().register(PORTABLE_CONDENSATION_DRIVE_CASING);
			event.getRegistry().register(PORTABLE_DENSE_CONDENSATION_DRIVE_CASING);
			event.getRegistry().register(CIRCUIT_PLATING);
			event.getRegistry().register(BASIC_CONTROL_CIRCUIT);
			event.getRegistry().register(ADVANCED_CONTROL_CIRCUIT);

			event.getRegistry().register(PILL_ANDROID);
			event.getRegistry().register(PILL_HUMANE);
			event.getRegistry().register(BATTERY_CRUDE);
			event.getRegistry().register(BATTERY_BASIC);
			event.getRegistry().register(BATTERY_NORMAL);
			event.getRegistry().register(BATTERY_DENSE);
			event.getRegistry().register(BATTERY_CAPACITOR);
			event.getRegistry().register(BATTERY_CREATIVE);

			event.getRegistry().register(MATTER_CAPACITOR_PARTS);
			event.getRegistry().register(MATTER_CAPACITOR_BASIC);
			event.getRegistry().register(MATTER_CAPACITOR_NORMAL);
			event.getRegistry().register(MATTER_CAPACITOR_DENSE);
			event.getRegistry().register(MATTER_CAPACITOR_CREATIVE);

			event.getRegistry().register(PATTERN_DRIVE_NORMAL);
			event.getRegistry().register(PATTERN_DRIVE_CREATIVE);
			event.getRegistry().register(PORTABLE_CONDENSATION_DRIVE);
			event.getRegistry().register(PORTABLE_DENSE_CONDENSATION_DRIVE);

			event.getRegistry().register(NUTRIENT_PASTE);

			event.getRegistry().register(TRITANIUM_BLOCK);
			event.getRegistry().register(TRITANIUM_STRIPED_BLOCK);
			event.getRegistry().register(CARBON_FIBRE_BLOCK);

			for (var crate : CRATES) {
				event.getRegistry().register(crate);
			}

			// OverdriveThatMatters.LOGGER.info("Registered items");
		}
	}

	public static class BlockEntities {
		public static final BlockEntityType<BlockEntityAndroidStation> ANDROID_STATION = BlockEntityType.Builder.of(BlockEntityAndroidStation::new, Blocks.ANDROID_STATION).build(null);
		public static final BlockEntityType<BlockEntityBatteryBank> BATTERY_BANK = BlockEntityType.Builder.of(BlockEntityBatteryBank::new, Blocks.BATTERY_BANK).build(null);
		public static final BlockEntityType<BlockEntityMatterDecomposer> MATTER_DECOMPOSER = BlockEntityType.Builder.of(BlockEntityMatterDecomposer::new, Blocks.MATTER_DECOMPOSER).build(null);
		public static final BlockEntityType<BlockEntityMatterCapacitorBank> MATTER_CAPACITOR_BANK = BlockEntityType.Builder.of(BlockEntityMatterCapacitorBank::new, Blocks.MATTER_CAPACITOR_BANK).build(null);
		public static final BlockEntityType<BlockEntityMatterCable> MATTER_CABLE = BlockEntityType.Builder.of(BlockEntityMatterCable::new, Blocks.MATTER_CABLE).build(null);
		public static final BlockEntityType<BlockEntityPatternStorage> PATTERN_STORAGE = BlockEntityType.Builder.of(BlockEntityPatternStorage::new, Blocks.PATTERN_STORAGE).build(null);
		public static final BlockEntityType<BlockEntityMatterScanner> MATTER_SCANNER = BlockEntityType.Builder.of(BlockEntityMatterScanner::new, Blocks.MATTER_SCANNER).build(null);
		public static final BlockEntityType<BlockEntityMatterPanel> MATTER_PANEL = BlockEntityType.Builder.of(BlockEntityMatterPanel::new, Blocks.MATTER_PANEL).build(null);
		public static final BlockEntityType<BlockEntityMatterReplicator> MATTER_REPLICATOR = BlockEntityType.Builder.of(BlockEntityMatterReplicator::new, Blocks.MATTER_REPLICATOR).build(null);
		public static final BlockEntityType<BlockEntityMatterBottler> MATTER_BOTTLER = BlockEntityType.Builder.of(BlockEntityMatterBottler::new, Blocks.MATTER_BOTTLER).build(null);
		public static final BlockEntityType<BlockEntityDriveViewer> DRIVE_VIEWER = BlockEntityType.Builder.of(BlockEntityDriveViewer::new, Blocks.DRIVE_VIEWER).build(null);
		public static final BlockEntityType<BlockEntityBlackHole> BLACK_HOLE = BlockEntityType.Builder.of(BlockEntityBlackHole::new, Blocks.BLACK_HOLE).build(null);
		public static final BlockEntityType<BlockEntityCargoCrate> CARGO_CRATE = BlockEntityType.Builder.of(BlockEntityCargoCrate::new, Blocks.CARGO_CRATE).build(null);

		static {
			ANDROID_STATION.setRegistryName(Names.ANDROID_STATION);
			BATTERY_BANK.setRegistryName(Names.BATTERY_BANK);
			MATTER_DECOMPOSER.setRegistryName(Names.MATTER_DECOMPOSER);
			MATTER_CAPACITOR_BANK.setRegistryName(Names.MATTER_CAPACITOR_BANK);
			MATTER_CABLE.setRegistryName(Names.MATTER_CABLE);
			PATTERN_STORAGE.setRegistryName(Names.PATTERN_STORAGE);
			MATTER_SCANNER.setRegistryName(Names.MATTER_SCANNER);
			MATTER_PANEL.setRegistryName(Names.MATTER_PANEL);
			MATTER_REPLICATOR.setRegistryName(Names.MATTER_REPLICATOR);
			MATTER_BOTTLER.setRegistryName(Names.MATTER_BOTTLER);
			DRIVE_VIEWER.setRegistryName(Names.DRIVE_VIEWER);
			BLACK_HOLE.setRegistryName(Names.BLACK_HOLE);
			CARGO_CRATE.setRegistryName(Names.CARGO_CRATE);
		}

		@SubscribeEvent
		public static void register(final RegistryEvent.Register<BlockEntityType<?>> event) {
			event.getRegistry().register(ANDROID_STATION);
			event.getRegistry().register(BATTERY_BANK);
			event.getRegistry().register(MATTER_DECOMPOSER);
			event.getRegistry().register(MATTER_CAPACITOR_BANK);
			event.getRegistry().register(MATTER_CABLE);
			event.getRegistry().register(PATTERN_STORAGE);
			event.getRegistry().register(MATTER_SCANNER);
			event.getRegistry().register(MATTER_PANEL);
			event.getRegistry().register(MATTER_REPLICATOR);
			event.getRegistry().register(MATTER_BOTTLER);
			event.getRegistry().register(DRIVE_VIEWER);
			event.getRegistry().register(BLACK_HOLE);
			event.getRegistry().register(CARGO_CRATE);

			// OverdriveThatMatters.LOGGER.info("Registered block entities");
		}


		@SubscribeEvent
		public static void registerRenderers(final FMLClientSetupEvent event) {
			BlockEntityRenderers.register(BLACK_HOLE, BlackHoleRenderer::new);
		}
	}

	public static class AndroidFeatures {
		public static final AndroidFeatureType<AndroidFeature> AIR_BAGS = new AndroidFeatureType<>(AndroidFeature::new);
		public static final AndroidFeatureType<AndroidLimbOverclocking> LIMB_OVERCLOCKING = new AndroidFeatureType<>(AndroidLimbOverclocking::new);
		public static final AndroidFeatureType<AndroidNanobotsRegeneration> NANOBOTS_REGENERATION = new AndroidFeatureType<>(AndroidNanobotsRegeneration::new);
		public static final AndroidFeatureType<AndroidNanobotsArmor> NANOBOTS_ARMOR = new AndroidFeatureType<>(AndroidNanobotsArmor::new);

		static {
			AIR_BAGS.setRegistryName(Names.AIR_BAGS);
			LIMB_OVERCLOCKING.setRegistryName(Names.LIMB_OVERCLOCKING);
			NANOBOTS_REGENERATION.setRegistryName(Names.NANOBOTS_REGENERATION);
			NANOBOTS_ARMOR.setRegistryName(Names.NANOBOTS_ARMOR);
		}

		@SubscribeEvent
		public static void register(final RegistryEvent.Register<AndroidFeatureType<?>> event) {
			event.getRegistry().register(AIR_BAGS);
			event.getRegistry().register(LIMB_OVERCLOCKING);
			event.getRegistry().register(NANOBOTS_REGENERATION);
			event.getRegistry().register(NANOBOTS_ARMOR);
		}
	}

	public static class AndroidResearch {
		public static final ResourceLocation ICONS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/android_upgrades.png");
		public static final SkinElement ICON_TRANSFER;
		public static final SkinElement ICON_ATTACK_BOOST;
		public static final SkinElement ICON_PLASMA_SHIELD_BOOST;
		public static final SkinElement ICON_CLOAK;
		public static final SkinElement ICON_GRAVITATIONAL_STABILIZER;
		public static final SkinElement ICON_AIR_BAGS;
		public static final SkinElement ICON_JUMP_BOOST;

		public static final SkinElement ICON_FEATHER_FALLING;
		public static final SkinElement ICON_ARC;
		public static final SkinElement ICON_ARROW;
		public static final SkinElement ICON_ARMOR;
		public static final SkinElement ICON_NANOBOTS;
		public static final SkinElement ICON_NIGHT_VISION;
		public static final SkinElement ICON_OXYGEN_SUPPLY;

		public static final SkinElement ICON_PLASMA_SHIELD;
		public static final SkinElement ICON_SHOCKWAVE;
		public static final SkinElement ICON_LIMB_OVERCLOCKING;
		public static final SkinElement ICON_STEP_ASSIST;
		public static final SkinElement ICON_ENDER_TELEPORT;
		public static final SkinElement ICON_WIRELESS_CHARGING;
		public static final SkinElement ICON_UNKNOWN;

		static {
			int x = 0;
			int y = 0;

			ICON_TRANSFER = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_ATTACK_BOOST = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_PLASMA_SHIELD_BOOST = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_CLOAK = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_GRAVITATIONAL_STABILIZER = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_AIR_BAGS = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_JUMP_BOOST = new SkinElement(ICONS, x, y, 18, 18, 126, 126);

			y += 18;
			x = 0;

			ICON_FEATHER_FALLING = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_ARC = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_ARROW = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_ARMOR = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_NANOBOTS = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_NIGHT_VISION = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_OXYGEN_SUPPLY = new SkinElement(ICONS, x, y, 18, 18, 126, 126);

			y += 18;
			x = 0;

			ICON_PLASMA_SHIELD = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_SHOCKWAVE = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_LIMB_OVERCLOCKING = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_STEP_ASSIST = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_ENDER_TELEPORT = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_WIRELESS_CHARGING = new SkinElement(ICONS, x, y, 18, 18, 126, 126); x += 18;
			ICON_UNKNOWN = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		}

		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> AIR_BAGS =
			new AndroidResearchBuilder()
				.setExperienceCost(18)
				.addFeatureResult(AndroidFeatures.AIR_BAGS)
				.withDescription()
				.withIcon(ICON_AIR_BAGS)
				.build();

		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] LIMB_OVERCLOCKING = new AndroidResearchType[4];
		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] NANOBOTS_REGENERATION = new AndroidResearchType[4];
		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] NANOBOTS_ARMOR_STRENGTH = new AndroidResearchType[3];
		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] NANOBOTS_ARMOR_SPEED = new AndroidResearchType[3];

		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> NANOBOTS =
			new AndroidResearchBuilder()
				.setExperienceCost(15)
				.withDescription()
				.withIcon(ICON_NANOBOTS)
				.build();

		public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> NANOBOTS_ARMOR =
			new AndroidResearchBuilder()
				.setExperienceCost(25)
				.withDescription()
				.addPrerequisite(Names.NANOBOTS)
				.addFeatureResult(Names.NANOBOTS_ARMOR)
				.withIcon(ICON_ARMOR)
				.build();

		static {
			AIR_BAGS.setRegistryName(Names.AIR_BAGS);
			NANOBOTS.setRegistryName(Names.NANOBOTS);
			NANOBOTS_ARMOR.setRegistryName(Names.NANOBOTS_ARMOR);

			for (int i = 0; i < 4; i++) {
				var limbs = new AndroidResearchBuilder()
					.setExperienceCost(18 + i * 8)
					.withIconText(new TextComponent(String.valueOf(i + 1)))
					.withIcon(ICON_LIMB_OVERCLOCKING)
					.withName(new TranslatableComponent("android_research.overdrive_that_matters.limb_overclocking", i + 1))
					.withDescription(new TranslatableComponent("android_research.overdrive_that_matters.limb_overclocking.description", (i + 1) * 8, (i + 1) * 6))
					.addFeatureResult(Names.LIMB_OVERCLOCKING, i);

				var regeneration = new AndroidResearchBuilder()
					.setExperienceCost(20 + i * 6)
					.withIconText(new TextComponent(String.valueOf(i + 1)))
					.withIcon(ICON_NANOBOTS)
					.withName(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration", i + 1))
					.withDescription(
						i > 0 ? new TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration.description_improve") : new TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration.description"))
					.addFeatureResult(Names.NANOBOTS_REGENERATION, i);

				if (i > 0) {
					limbs.addPrerequisite(Names.LIMB_OVERCLOCKING_LIST[i - 1]);
					regeneration.addPrerequisite(Names.NANOBOTS_REGENERATION_LIST[i - 1]);
				} else {
					regeneration.addPrerequisite(Names.NANOBOTS);
				}

				LIMB_OVERCLOCKING[i] = limbs.build();
				NANOBOTS_REGENERATION[i] = regeneration.build();
			}

			for (int i = 0; i < 3; i++) {
				final int level = i + 1;

				NANOBOTS_ARMOR_STRENGTH[i] = new AndroidResearchBuilder()
					.setExperienceCost(20 + i * 8)
					.withIconText(new TextComponent(String.valueOf(i + 1)))
					.withIcon(ICON_ARMOR)
					.addPrerequisite(i > 0 ? Names.NANOBOTS_ARMOR_STRENGTH_LIST[i - 1] : Names.NANOBOTS_ARMOR)
					.withName(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_strength", i + 1))
					.withDescription(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_strength.description", (i + 1) * 8, (i + 1) * 6))
					.addFeatureResult(Names.NANOBOTS_ARMOR, 0, (feature) -> {
						if (((AndroidNanobotsArmor) feature).getStrength() < level)
							((AndroidNanobotsArmor) feature).setStrength(level);
					})
					.build();

				NANOBOTS_ARMOR_SPEED[i] = new AndroidResearchBuilder()
					.setExperienceCost(20 + i * 8)
					.withIconText(new TextComponent(String.valueOf(i + 1)))
					.withIcon(ICON_ARMOR)
					.addPrerequisite(i > 0 ? Names.NANOBOTS_ARMOR_SPEED_LIST[i - 1] : Names.NANOBOTS_ARMOR)
					.withName(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_speed", i + 1))
					.withDescription(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_speed.description", (i + 1) * 8, (i + 1) * 6))
					.addFeatureResult(Names.NANOBOTS_ARMOR, 0, (feature) -> {
						if (((AndroidNanobotsArmor) feature).getSpeed() < level)
							((AndroidNanobotsArmor) feature).setSpeed(level);
					})
					.build();
			}

			LIMB_OVERCLOCKING[0].setRegistryName(Names.LIMB_OVERCLOCKING_1);
			LIMB_OVERCLOCKING[1].setRegistryName(Names.LIMB_OVERCLOCKING_2);
			LIMB_OVERCLOCKING[2].setRegistryName(Names.LIMB_OVERCLOCKING_3);
			LIMB_OVERCLOCKING[3].setRegistryName(Names.LIMB_OVERCLOCKING_4);

			NANOBOTS_ARMOR_SPEED[0].setRegistryName(Names.NANOBOTS_ARMOR_SPEED_1);
			NANOBOTS_ARMOR_SPEED[1].setRegistryName(Names.NANOBOTS_ARMOR_SPEED_2);
			NANOBOTS_ARMOR_SPEED[2].setRegistryName(Names.NANOBOTS_ARMOR_SPEED_3);

			NANOBOTS_ARMOR_STRENGTH[0].setRegistryName(Names.NANOBOTS_ARMOR_STRENGTH_1);
			NANOBOTS_ARMOR_STRENGTH[1].setRegistryName(Names.NANOBOTS_ARMOR_STRENGTH_2);
			NANOBOTS_ARMOR_STRENGTH[2].setRegistryName(Names.NANOBOTS_ARMOR_STRENGTH_3);

			NANOBOTS_REGENERATION[0].setRegistryName(Names.NANOBOTS_REGENERATION_1);
			NANOBOTS_REGENERATION[1].setRegistryName(Names.NANOBOTS_REGENERATION_2);
			NANOBOTS_REGENERATION[2].setRegistryName(Names.NANOBOTS_REGENERATION_3);
			NANOBOTS_REGENERATION[3].setRegistryName(Names.NANOBOTS_REGENERATION_4);
		}

		@SubscribeEvent
		public static void register(final RegistryEvent.Register<AndroidResearchType<?>> event) {
			event.getRegistry().register(AIR_BAGS);
			event.getRegistry().register(NANOBOTS);
			event.getRegistry().register(NANOBOTS_ARMOR);

			event.getRegistry().register(LIMB_OVERCLOCKING[0]);
			event.getRegistry().register(LIMB_OVERCLOCKING[1]);
			event.getRegistry().register(LIMB_OVERCLOCKING[2]);
			event.getRegistry().register(LIMB_OVERCLOCKING[3]);

			event.getRegistry().register(NANOBOTS_ARMOR_SPEED[0]);
			event.getRegistry().register(NANOBOTS_ARMOR_SPEED[1]);
			event.getRegistry().register(NANOBOTS_ARMOR_SPEED[2]);
			event.getRegistry().register(NANOBOTS_ARMOR_STRENGTH[0]);
			event.getRegistry().register(NANOBOTS_ARMOR_STRENGTH[1]);
			event.getRegistry().register(NANOBOTS_ARMOR_STRENGTH[2]);

			event.getRegistry().register(NANOBOTS_REGENERATION[0]);
			event.getRegistry().register(NANOBOTS_REGENERATION[1]);
			event.getRegistry().register(NANOBOTS_REGENERATION[2]);
			event.getRegistry().register(NANOBOTS_REGENERATION[3]);
		}
	}

	public static class Menus {
		public static final MenuType<AndroidStationMenu> ANDROID_STATION = new MenuType<>(AndroidStationMenu::new);
		public static final MenuType<BatteryBankMenu> BATTERY_BANK = new MenuType<>(BatteryBankMenu::new);
		public static final MenuType<MatterDecomposerMenu> MATTER_DECOMPOSER = new MenuType<>(MatterDecomposerMenu::new);
		public static final MenuType<MatterCapacitorBankMenu> MATTER_CAPACITOR_BANK = new MenuType<>(MatterCapacitorBankMenu::new);
		public static final MenuType<PatternStorageMenu> PATTERN_STORAGE = new MenuType<>(PatternStorageMenu::new);
		public static final MenuType<MatterScannerMenu> MATTER_SCANNER = new MenuType<>(MatterScannerMenu::new);
		public static final MenuType<MatterPanelMenu> MATTER_PANEL = new MenuType<>(MatterPanelMenu::new);
		public static final MenuType<MatterReplicatorMenu> MATTER_REPLICATOR = new MenuType<>(MatterReplicatorMenu::new);
		public static final MenuType<MatterBottlerMenu> MATTER_BOTTLER = new MenuType<>(MatterBottlerMenu::new);
		public static final MenuType<DriveViewerMenu> DRIVE_VIEWER = new MenuType<>(DriveViewerMenu::new);
		public static final MenuType<CargoCrateMenu> CARGO_CRATE = new MenuType<>(CargoCrateMenu::new);

		static {
			ANDROID_STATION.setRegistryName(Names.ANDROID_STATION);
			BATTERY_BANK.setRegistryName(Names.BATTERY_BANK);
			MATTER_DECOMPOSER.setRegistryName(Names.MATTER_DECOMPOSER);
			MATTER_CAPACITOR_BANK.setRegistryName(Names.MATTER_CAPACITOR_BANK);
			PATTERN_STORAGE.setRegistryName(Names.PATTERN_STORAGE);
			MATTER_SCANNER.setRegistryName(Names.MATTER_SCANNER);
			MATTER_PANEL.setRegistryName(Names.MATTER_PANEL);
			MATTER_REPLICATOR.setRegistryName(Names.MATTER_REPLICATOR);
			MATTER_BOTTLER.setRegistryName(Names.MATTER_BOTTLER);
			DRIVE_VIEWER.setRegistryName(Names.DRIVE_VIEWER);
			CARGO_CRATE.setRegistryName(Names.CARGO_CRATE);
		}

		@SubscribeEvent
		public static void register(final RegistryEvent.Register<MenuType<?>> event) {
			event.getRegistry().register(ANDROID_STATION);
			event.getRegistry().register(BATTERY_BANK);
			event.getRegistry().register(MATTER_DECOMPOSER);
			event.getRegistry().register(MATTER_CAPACITOR_BANK);
			event.getRegistry().register(PATTERN_STORAGE);
			event.getRegistry().register(MATTER_SCANNER);
			event.getRegistry().register(MATTER_PANEL);
			event.getRegistry().register(MATTER_REPLICATOR);
			event.getRegistry().register(MATTER_BOTTLER);
			event.getRegistry().register(DRIVE_VIEWER);
			event.getRegistry().register(CARGO_CRATE);

			// OverdriveThatMatters.LOGGER.info("Registered menus");
		}

		@SubscribeEvent
		public static void registerScreens(final FMLClientSetupEvent event) {
			MenuScreens.register(ANDROID_STATION, AndroidStationScreen::new);
			MenuScreens.register(BATTERY_BANK, BatteryBankScreen::new);
			MenuScreens.register(MATTER_DECOMPOSER, MatterDecomposerScreen::new);
			MenuScreens.register(MATTER_CAPACITOR_BANK, MatterCapacitorBankScreen::new);
			MenuScreens.register(PATTERN_STORAGE, PatternStorageScreen::new);
			MenuScreens.register(MATTER_SCANNER, MatterScannerScreen::new);
			MenuScreens.register(MATTER_PANEL, MatterPanelScreen::new);
			MenuScreens.register(MATTER_REPLICATOR, MatterReplicatorScreen::new);
			MenuScreens.register(MATTER_BOTTLER, MatterBottlerScreen::new);
			MenuScreens.register(DRIVE_VIEWER, DriveViewerScreen::new);
			MenuScreens.register(CARGO_CRATE, CargoCrateScreen::new);

			// OverdriveThatMatters.LOGGER.info("Registered screens");
		}
	}

	public static class Stats {
		@SubscribeEvent
		public static void registerVanilla(final FMLCommonSetupEvent event) {
			net.minecraft.core.Registry.register(net.minecraft.core.Registry.CUSTOM_STAT, Names.DAMAGE_ABSORBED, Names.DAMAGE_ABSORBED);
			net.minecraft.core.Registry.register(net.minecraft.core.Registry.CUSTOM_STAT, Names.HEALTH_REGENERATED, Names.HEALTH_REGENERATED);
			net.minecraft.core.Registry.register(net.minecraft.core.Registry.CUSTOM_STAT, Names.POWER_CONSUMED, Names.POWER_CONSUMED);

			net.minecraft.stats.Stats.CUSTOM.get(Names.DAMAGE_ABSORBED, StatFormatter.DIVIDE_BY_TEN);
			net.minecraft.stats.Stats.CUSTOM.get(Names.HEALTH_REGENERATED, StatFormatter.DIVIDE_BY_TEN);
			net.minecraft.stats.Stats.CUSTOM.get(Names.POWER_CONSUMED, StatFormatter.DIVIDE_BY_TEN);
		}
	}
}
