package ru.dbotthepony.mc.otm.android.feature;

import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.ai.attributes.Attributes;
import ru.dbotthepony.mc.otm.android.AndroidFeature;
import ru.dbotthepony.mc.otm.android.AndroidFeatureType;
import ru.dbotthepony.mc.otm.capability.IAndroidCapability;

import java.util.UUID;

public class AndroidLimbOverclocking extends AndroidFeature {
	public static final UUID MODIFIER_ID = UUID.fromString("4a3fae46-e57b-4e20-857d-f5c2b2c8f2f2");

	public AndroidLimbOverclocking(AndroidFeatureType<?> type, IAndroidCapability capability) {
		super(type, capability);
	}

	@Override
	public void applyModifiers() {
		var speed = capability.getEntity().getAttribute(Attributes.MOVEMENT_SPEED);

		if (speed != null) {
			speed.removePermanentModifier(MODIFIER_ID);
			speed.addPermanentModifier(new AttributeModifier(MODIFIER_ID, type.getDisplayName().toString(), 0.08d * (level + 1), AttributeModifier.Operation.MULTIPLY_TOTAL));
		}

		var attack_speed = capability.getEntity().getAttribute(Attributes.ATTACK_SPEED);

		if (attack_speed != null) {
			attack_speed.removePermanentModifier(MODIFIER_ID);
			attack_speed.addPermanentModifier(new AttributeModifier(MODIFIER_ID, type.getDisplayName().toString(), 0.06d * (level + 1), AttributeModifier.Operation.MULTIPLY_TOTAL));
		}
	}

	@Override
	public void removeModifiers() {
		var speed = capability.getEntity().getAttribute(Attributes.MOVEMENT_SPEED);

		if (speed != null) {
			speed.removePermanentModifier(MODIFIER_ID);
		}

		var attack_speed = capability.getEntity().getAttribute(Attributes.ATTACK_SPEED);

		if (attack_speed != null) {
			attack_speed.removePermanentModifier(MODIFIER_ID);
		}
	}
}
