package ru.dbotthepony.mc.otm.block;

import net.minecraft.core.BlockPos;
import net.minecraft.world.Container;
import net.minecraft.world.Containers;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.BooleanProperty;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityCargoCrate;

import javax.annotation.Nullable;

public class BlockCargoCrate extends BlockMatteryRotatable implements EntityBlock {
	public static final BooleanProperty IS_OPEN = BooleanProperty.create("open");

	@Nullable
	@Override
	public BlockEntity newBlockEntity(BlockPos blockPos, BlockState blockState) {
		return new BlockEntityCargoCrate(blockPos, blockState);
	}

	@Override
	protected void createBlockStateDefinition(StateDefinition.Builder<Block, BlockState> builder) {
		super.createBlockStateDefinition(builder);
		builder.add(IS_OPEN);
	}

	@Nullable
	@Override
	public BlockState getStateForPlacement(BlockPlaceContext context) {
		return super.getStateForPlacement(context).setValue(IS_OPEN, false);
	}

	@Override
	public void onRemove(BlockState old_block_state, Level level, BlockPos block_pos, BlockState new_block_state, boolean p_51542_) {
		if (!old_block_state.is(new_block_state.getBlock())) {
			BlockEntity blockentity = level.getBlockEntity(block_pos);

			if (blockentity instanceof BlockEntityCargoCrate crate) {
				Containers.dropContents(level, block_pos, crate.slots);
				level.updateNeighbourForOutputSignal(block_pos, this);
			}

			super.onRemove(old_block_state, level, block_pos, new_block_state, p_51542_);
		}
	}
}
