package ru.dbotthepony.mc.otm.client;

import net.minecraftforge.client.event.InputUpdateEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.capability.AndroidCapabilityPlayer;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;

public class EventHandler {
	@SubscribeEvent
	public static void inputEvent(InputUpdateEvent event) {
		var ply = event.getPlayer();
		var input = event.getMovementInput();

		ply.getCapability(MatteryCapability.ANDROID).ifPresent(_cap -> {
			if (!(_cap instanceof AndroidCapabilityPlayer cap))
				return;

			if (cap.hasFeature(Registry.AndroidFeatures.AIR_BAGS))
				return;

			if (ply.getAbilities().mayfly) {
				cap.last_jump_ticks = 14;
			} else {
				if (ply.isInWater()) {
					if (ply.isOnGround()) {
						cap.last_jump_ticks = 14;
					}

					if (ply.isSwimming()) {
						ply.setSwimming(false);
					}

					if (cap.last_jump_ticks <= 0) {
						event.getMovementInput().jumping = false;
						event.getMovementInput().up = false;
					} else {
						cap.last_jump_ticks--;
					}
				}
			}
		});
	}
}
