package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.block.entity.BlockEntity;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityCargoCrate;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;

public class CargoCrateMenu extends MatteryMenu {
	public CargoCrateMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public final MatterySlot[] crate_slots = new MatterySlot[9 * 6];

	public CargoCrateMenu(int p_38852_, Inventory inventory, BlockEntityCargoCrate tile) {
		super(Registry.Menus.CARGO_CRATE, p_38852_, inventory, tile);
		var container = tile != null ? tile.slots : new SimpleContainer(9 * 6);

		for (int i = 0; i < container.getContainerSize(); i++) {
			crate_slots[i] = new MatterySlot(container, i);
			addSlot(crate_slots[i]);
		}

		if (tile != null)
			tile.onPlayerOpen();

		addInventorySlots();
	}

	@Override
	public void removed(Player p_38940_) {
		super.removed(p_38940_);

		if (tile != null)
			((BlockEntityCargoCrate) tile).onPlayerClose();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 9 * 6 + 1;
	}
}
