package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterReplicator;
import ru.dbotthepony.mc.otm.menu.slot.MachineOutputSlot;
import ru.dbotthepony.mc.otm.menu.widget.MatterLevelWidget;
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget;

public class MatterReplicatorMenu extends PoweredMatteryMenu {
	public MatterReplicatorMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public MatterLevelWidget matter_widget;
	public ProgressGaugeWidget progress;
	public MachineOutputSlot[] output_slots = new MachineOutputSlot[3];

	public MatterReplicatorMenu(int p_38852_, Inventory inventory, BlockEntityMatterReplicator tile) {
		super(Registry.Menus.MATTER_REPLICATOR, p_38852_, inventory, tile);

		Container container = tile != null ? tile.regular_slots : new SimpleContainer(3);

		for (int i = 0; i < container.getContainerSize(); i++) {
			output_slots[i] = new MachineOutputSlot(container, i, 64 + 18 * i, 38, true);
			addSlot(output_slots[i]);
		}

		if (tile != null) {
			matter_widget = new MatterLevelWidget(this, 22, 14, tile.matter);
			progress = new ProgressGaugeWidget(this, 38, 38, () -> (float) tile.getWorkProgress(), tile::cantProcessJob);
		} else {
			matter_widget = new MatterLevelWidget(this, 22, 14);
			progress = new ProgressGaugeWidget(this, 38, 38);
		}

		addBatterySlot(14);
		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 5;
	}
}
