package ru.dbotthepony.mc.otm.menu.data;

import net.minecraft.world.inventory.ContainerData;
import org.apache.commons.lang3.ArrayUtils;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;

import java.math.BigDecimal;
import java.math.BigInteger;

public class LongDataContainer implements ContainerData {
	public static final int NETWORK_PAYLOAD_SIZE = 4;

	private Long value;
	private final int[] buffer = new int[NETWORK_PAYLOAD_SIZE];

	public Long getValue() {
		if (value != null) {
			return value;
		}

		long a = buffer[0];
		long b = buffer[1];
		long c = buffer[2];
		long d = buffer[3];

		return value = a | b << 16 | c << 32 | d << 48;
	}

	public void setValue(long value) {
		if (this.value != null && value == this.value) {
			return;
		}

		this.value = value;
		buffer[0] = (int) ((value) & 0xFFFF);
		buffer[1] = (int) ((value >>> 16) & 0xFFFF);
		buffer[2] = (int) ((value >>> 32) & 0xFFFF);
		buffer[3] = (int) ((value >>> 48) & 0xFFFF);
	}

	// override
	protected void updateValue() {

	}

	@Override
	public int get(int index) {
		updateValue();
		return buffer[index];
	}

	@Override
	public void set(int index, int _value) {
		if (buffer[index] == _value)
			return;

		value = null;
		buffer[index] = _value;
	}

	@Override
	public int getCount() {
		return NETWORK_PAYLOAD_SIZE;
	}
}
