package ru.dbotthepony.mc.otm.network;

import net.minecraft.network.FriendlyByteBuf;

import java.math.BigDecimal;
import java.math.BigInteger;

public class NetworkHelper {
	public static BigDecimal readDecimal(FriendlyByteBuf buffer) {
		int scale = buffer.readInt();
		int length = buffer.readByte() & 0xFF;
		byte[] bytes = new byte[length];

		for (int i = 0; i < length; i++)
			bytes[i] = buffer.readByte();

		return new BigDecimal(new BigInteger(bytes), scale);
	}

	public static void writeDecimal(FriendlyByteBuf buffer, BigDecimal value) {
		buffer.writeInt(value.scale());
		byte[] build = value.unscaledValue().toByteArray();
		buffer.writeByte(build.length);
		for (byte b : build) buffer.writeByte(b);
	}
}
